import { AbstractLogger } from "../logging/AbstractLogger";
import { AbstractConfiguration } from "../system/AbstractConfiguration";
export interface ISetConfigurations {
    setConfigurations<T extends AbstractConfiguration>(configurationClass: {
        new (): T;
    }, environment: string, configurationResolver: (environment: string) => Promise<object>): ISetLogger<any, any>;
}
export interface ISetLogger<T, L> {
    setLogger(loggerResolver: (config: T) => AbstractLogger): L;
}
export declare class ClaireAppBuilderTerminal {
    configurationClass: {
        new (): AbstractConfiguration;
    };
    environment: string;
    configurationResolver: (environment: string) => Promise<object>;
    loggerResolver: (config: any) => AbstractLogger;
}
export declare class ClaireAppBuilder<L, K extends ClaireAppBuilderTerminal & L> implements ISetConfigurations, ISetLogger<any, L> {
    protected builderTerminal: K;
    setConfigurations<T extends AbstractConfiguration>(configurationClass: new () => T, environment: string, configurationResolver: (environment: string) => Promise<object>): ISetLogger<T, L>;
    setLogger(loggerResolver: (config: any) => AbstractLogger): L;
}
//# sourceMappingURL=ClaireAppBuilder.d.ts.map