import { AbstractModel } from "../model/AbstractModel";
import { IStartStop } from "../system/IStartStop";
export declare const getInjectionRegistry: () => InjectionRegistry;
export interface InjectableInfo<T> {
    instance: T;
    environments?: string[];
}
export interface InjectionTargetInfo {
    targetPrototype?: any;
    propertyKey: string;
    fieldConstructor: any;
}
export declare class InjectionRegistry {
    private injectables;
    private targets;
    private store;
    private models;
    getInitableInjectables(): IStartStop[];
    get<T>(key: string): T;
    set(key: string, value: any): void;
    registerModel(model: {
        new (): AbstractModel;
    }): void;
    getModels(): {
        new (): AbstractModel;
    }[];
    registerTarget(info: InjectionTargetInfo): void;
    replaceTarget(filter: (target: InjectionTargetInfo) => boolean, newTarget: Partial<InjectionTargetInfo>): void;
    registerInjectable(constructor: {
        new (): any;
    }, environments?: string[]): void;
    replaceInjectable<T, K extends T>(instance: K, instanceClass: Function & {
        prototype: T;
    }): void;
    filterInjectable<T>(instanceSuperClass: Function & {
        prototype: T;
    }): T[];
    getInjectable<T>(instanceSuperClass: Function & {
        prototype: T;
    }, env?: string): T;
    performInjection(currentEnv: string | undefined, ignoreMissing?: boolean): void;
}
//# sourceMappingURL=injection.d.ts.map